      PROGRAM algSearch
************************************************************************
* Analogue Search Program
* 
* Sebastian Kopf 2006
* Coding Standards used approximately:
* http://dbwww.essc.psu.edu/lasdoc/programmer/4fortran.html
*
* Program controlled via Makefile
* Usage described in INSTALL.TXT
*
* All subroutines and functions described in their headers.
*
************************************************************************

      IMPLICIT none
*     Main routine for the entire program of climate analogue search

      INTEGER x, y, futX, futY, a !grid size
      INTEGER tX, tY ! transformation grid size for visualisation
      INTEGER curYearOffset, futYearOffset
      INTEGER citynum
      PARAMETER(citynum=25) !max number of cities read
      CHARACTER*50 cityName(citynum) !cities
      REAL cityLat(citynum), cityLon(citynum) !cities' coordinates

      INTEGER method !method to use when searching for analogues
      
      ! whether to create the overview, pvalue table and individual visulisation maps
      LOGICAL overview, table, visualisation 
      
      INTEGER strlen, i !funcs and looping var
      CHARACTER cityF*100, configF*100, line*50, eq*20, q*3 !config reads
      CHARACTER resultsP*100 ! results path
      CHARACTER model*50 !model

      CHARACTER*(20)
     c curDataFormat, futDataFormat
      CHARACTER*(100) 
     c curTempFile, futTempFile, curPrecFile, futPrecFile
       
      EXTERNAL processModel
       
      ! read model configuration
      configF = "model.conf"
      print *, "Reading configuration file ",
     c      "'", configF(1:strlen(configF)),
     c      "'..." 
     
      ! read it
      OPEN (11,file=configF(1:strlen(configF)))
            read(11,*) line ! starting line
            read(11,*) line, eq, method
            read(11,*) line, eq, q
            if (q=="yes") overview=.TRUE.
            if (q=="no") overview=.FALSE.
            read(11,*) line, eq, q
            if (q=="yes") table=.TRUE.
            if (q=="no") table=.FALSE.
            read(11,*) line, eq, q
            if (q=="yes") visualisation=.TRUE.
            if (q=="no") visualisation=.FALSE.
            read(11,*) line, eq, resultsP
            resultsP=resultsP(1:strlen(resultsP))//"/" ! in case it got stripped
            read(11,*) line, eq, model
            read(11,*) line, eq, x
            read(11,*) line, eq, y
            read(11,*) line, eq, futX
            read(11,*) line, eq, futY
            read(11,*) line, eq, tX
            read(11,*) line, eq, tY
            read(11,*) line, eq, a
            read(11,*) line, eq, curYearOffset
            read(11,*) line, eq, futYearOffset
            read(11,*) line, eq, curTempFile
            read(11,*) line, eq, curPrecFile
            read(11,*) line, eq, curDataFormat
            read(11,*) line, eq, futTempFile
            read(11,*) line, eq, futPrecFile
            read(11,*) line, eq, futDataFormat
      CLOSE(11)      
       
      ! read cities configuration
      cityF = "cities.conf"
      print *, "Reading cities' configuration file ",
     c      "'", cityF(1:strlen(cityF)),
     c      "'..." 

      ! read it
      i = 1
      OPEN (11,file=cityF(1:strlen(cityF)))
         READ(11,*,end=15) line ! starting line
  14     READ(11,*,end=15) cityName(i), cityLat(i), cityLon(i)
         i = i + 1
         goto 14
  15  CLOSE(11)

      
      print *, "Processing model ", 
     c      "'", model(1:strlen(model)), 
     c      "' for", i-1, " cities..."

      CALL processModel(
     c      overview, table, visualisation, method, 
     c      resultsP, model,
     c      x,y,futX,futY,tX,tY,a,
     c      curYearOffset,futYearOffset,
     c      i-1, cityName, cityLat, cityLon,
     c      curTempFile, curPrecFile, curDataFormat,
     c      futTempFile, futPrecFile, futDataFormat )
      
      END
      
