      SUBROUTINE handleErr (errId)
************************************************************************
* Handles NetCDF errors.
* TODO: extend me, more precise error info
* NetCDF INFO: http://www.unidata.ucar.edu/software/netcdf/guidef/ 
*
* Input: errId(Integer): the ID of the error
************************************************************************
      INCLUDE 'netcdf.inc'
      
      INTEGER errId
      
      IF (errId .NE. NF_NOERR) THEN
            PRINT *, errId, NF_STRERROR(errId)
            STOP 'NetCDF Error occured'
      ENDIF
      
      END       


      SUBROUTINE netCdfInfo (p_fileName)
************************************************************************
* NOTE: this function is not used anywhere in the final version of the program.
* Helper function to display info about a netcdf file at once on standard output. 
* Finishes with a program stop (!)
* NetCDF INFO: http://www.unidata.ucar.edu/software/netcdf/guidef/ 
*
* Input:
*  - p_fileName(String): name of the NetCDF file to be analysed  
************************************************************************
      IMPLICIT none
      INCLUDE 'netcdf.inc'
      CHARACTER p_fileName*(*), fileN*100 ! input, variable name
      INTEGER NCID
      INTEGER NDIMS, NVARS, NGATTS, UNLIMDIMID, DIML
      CHARACTER*(NF_MAX_NAME) DIMNAME
      INTEGER  RHID               ! variable ID
      CHARACTER*31 RHNAME, ANAME, ATVAL        ! variable name
      INTEGER  RHTYPE  , ATYPE           ! variable type
      INTEGER  RHN , ALENGTH    ! number of dimensions
      INTEGER  RHDIMS(NF_MAX_VAR_DIMS)   ! variable shape
      INTEGER  RHNATT                  ! number of attributes
      INTEGER i,j, strlen
            
       fileN = p_fileName      
      
       CALL handleErr(
     c  nf_open(fileN(1:strlen(fileN)), 
     c  NF_CLOBBER,NCID))
         
         CALL handleErr (
     c  NF_INQ(NCID, NDIMS, NVARS, NGATTS, UNLIMDIMID) )
         
         print *, NDIMS, NVARS, NGATTS, UNLIMDIMID
         
         do i=1, NDIMS
               CALL handleErr (
     c       NF_INQ_DIM     (NCID, i, DIMNAME, DIML))
               print *, "dim ", i, ": ", DIMNAME(1:strlen(DIMNAME)),
     c        "(",DIML,")"
         enddo
         
         do i=1, NVARS
            CALL handleErr (
     c    NF_INQ_VAR (NCID, i, RHNAME, RHTYPE, RHN, RHDIMS, RHNATT) )
            print *, "var ", i, ": ", RHNAME(1:strlen(RHNAME)),
     c    ", type: ", RHTYPE, " dims: ", RHN, 
     c    " shape: ", RHDIMS(1), RHDIMS(2), RHDIMS(3),
     c    ", attribs: ", RHNATT
               do j=1, RHNATT
                  CALL handleErr (
     c          NF_INQ_ATTNAME(NCID, i, j, ANAME))
                  CALL handleErr (
     c         NF_INQ_ATT (NCID, i, ANAME, ATYPE, ALENGTH) )
                  print *, "   attrib ", j, ": ", ANAME, 
     c           " type: ", ATYPE, " length: ", ALENGTH
                 if (ATYPE == NF_CHAR) then
              CALL handleErr(NF_GET_ATT_TEXT (NCID, i, ANAME, ATVAL))
                     print *, "       value: ", ATVAL(1:ALENGTH)
                 endif
               enddo
         enddo
      
        print *, "global attributes:"
            
             j=0
   5         j=j+1
                  CALL handleErr (
     c          NF_INQ_ATTNAME(NCID, NF_GLOBAL, j, ANAME))
                  CALL handleErr (
     c         NF_INQ_ATT (NCID, NF_GLOBAL, ANAME, ATYPE, ALENGTH) )
                  print *, "   attrib ", j, ": ", ANAME, 
     c           " type: ", ATYPE, " length: ", ALENGTH
                 if (ATYPE == NF_CHAR) then
              CALL handleErr(NF_GET_ATT_TEXT (NCID, 
     c                  NF_GLOBAL, ANAME, ATVAL))
                     print *, "       value: ", ATVAL(1:ALENGTH)
                 endif
             goto 5
      
      
      END
